:- include('listen.pl').

/* ====== Permutationen ====== */
permutationen([],[]).
permutationen([Anfang|Rest],Permutation):-
   permutationen(Rest, Restpermutation),
   delete(Permutation,Anfang,Restpermutation). /* Anfang irgendwo einfuegen */


/* ====== Teilmengen ====== */
teilmengen([],[]).
teilmengen([_|Rest],Teilmenge):- /*Anfang nicht in Teilmenge enthalten*/
   teilmengen(Rest,Teilmenge).
teilmengen([Element|Rest],[Element|Teilmenge]):- /* Anfang enthalten */
   teilmengen(Rest,Teilmenge).


/* ====== Folgen ====== */
folgen(0,_,[]).
folgen(N,Grundmenge,[Anfang|Rest]):-
   N > 0,
   N1 is N-1,
   folgen(N1,Grundmenge,Rest),
   member(Anfang,Grundmenge). /* hole beliebigen Anfang aus der Grundmenge */


/* ====== sortierte Folgen ====== */
sortiertefolgen(0,_,[]).

/* Anfang der Grundmenge verwenden */
sortiertefolgen(N,[Anfang|GrundmengenRest],[Anfang|Rest]):-
   N > 0,
   N1 is N-1,
   sortiertefolgen(N1,[Anfang|GrundmengenRest],Rest).
/* Anfang der Grundmenge nicht verwenden */
sortiertefolgen(N,[_|GrundmengenRest],Folge):-
   N > 0,
   sortiertefolgen(N,GrundmengenRest,Folge).


/* ====== Listenzahl ====== */
listenzahl([],1,0).
listenzahl([Anfang|Rest],Potenz,Zahl):-
   listenzahl(Rest,Potenz2,RestZahl),
   Potenz is Potenz2 * 10,
   Zahl is RestZahl + Potenz2*Anfang.
