
member([Element|_],0,Element).
member([_|Restliste], Position, Element):-
   member(Restliste,PositionInRestliste,Element),
   Position is PositionInRestliste+1.


/* ========================================================================== */


merge([],X,X):-!.
merge(X,[],X):-!.
merge([A|R],[B|L],[A|RekResult]):-
   A =< B, !,
   merge(R,[B|L],RekResult).
merge(R,[B|L],[B|RekResult]):-
   merge(R,L,RekResult). /* B > A is certain because of the red cut in the first clause */


mergesort([],[]):-!.
mergesort([X],[X]):-!.
mergesort(Liste, Sortiert):-
   length(Liste,Laenge),
   findall(Element, Pos^(member(Liste,Pos,Element),Pos < Laenge//2), Links ),   /* linke Teilliste bestimmen */
   findall(Element, Pos^(member(Liste,Pos,Element),Pos >= Laenge//2), Rechts ), /* rechte Teilliste bestimmen */
   mergesort(Links, LinksSortiert),                                             /* rekursion auf linker Teilliste */
   mergesort(Rechts, RechtsSortiert),                                           /* rekursion auf rechter Teilliste */
   merge(LinksSortiert,RechtsSortiert,Sortiert).                                /* mergen */



quicksort([],[]):-!.
quicksort([X],[X]):-!.
quicksort([Median|Liste],Sortiert):-
   findall(Element,(member(Element, Liste),Element < Median), Links),
   findall(Element,(member(Element, Liste),Element >= Median), Rechts),
   quicksort(Links,LinksSortiert),
   quicksort(Rechts,RechtsSortiert),
   append(LinksSortiert,[Median|RechtsSortiert],Sortiert).


