derivation(X, C, 0):-
   atomic(C),
   C \= X.
derivation(X, X, 1).
derivation(X, X^M, M*X^M1):-
   (integer(M); float(M)),
   M1 is M-1.
derivation(X, X^(A/B), (A/B)*X^(A1/B)):-
   A1 is A-B.

derivation(X, A+B, DA+DB):-
   derivation(X, A,DA),
   derivation(X, B,DB).
derivation(X, -A, -DA):-
   derivation(X,A,DA).
derivation(X, A-B, DA-DB):-
   derivation(X, A,DA),
   derivation(X, B,DB).
derivation(X, A*B, A*DB+DA*B):-
   derivation(X, A, DA),
   derivation(X, B, DB).
derivation(X, A/B, (DA*B-A*DB)/(B*B)):-
   derivation(X, A,DA),
   derivation(X, B,DB).


derivation(X, sin(Y), cos(Y)*DY):-
   derivation(X,Y,DY).
derivation(X, cos(Y), -sin(Y)*DY):-
   derivation(X,Y,DY).
derivation(X, tan(Y), (1/cos(Y)^2)*DY):-
   derivation(X,Y,DY).
derivation(X, cot(Y), -(1/sin(Y)^2)*DY):-
   derivation(X,Y,DY).

derivation(X, exp(Y), exp(Y)*DY):-
   derivation(X,Y,DY).
derivation(X, A^Y, A^Y*ln(A)*DY):-
   A \= X,
   derivation(X,Y,DY).
derivation(X, ln(Y), DY/Y):-
   derivation(X,Y,DY).
derivation(X, log(A,Y), 1/(Y*ln(A))*DY):-
   derivation(X,Y,DY).

derivation(X, arcsin(Y), (1-Y^2)^(-(1/2))*DY):-
   derivation(X,Y,DY).
derivation(X, arccos(Y), -((1-Y^2)^(-(1/2)))*DY):-
   derivation(X,Y,DY).
derivation(X, arctan(Y), DY/(1+Y^2)):-
   derivation(X,Y,DY).
derivation(X, arccot(Y), -(DY/(1+Y^2))):-
   derivation(X,Y,DY).